diff --git a/xen/arch/arm/Makefile b/xen/arch/arm/Makefile
index 5ae5831..6e1208f 100644
--- a/xen/arch/arm/Makefile
+++ b/xen/arch/arm/Makefile
@@ -27,7 +27,7 @@ obj-y += shutdown.o
 obj-y += traps.o
 obj-y += vgic.o
 obj-y += vtimer.o
-obj-y += vpl011.o
+obj-y += vuart.o
 obj-y += hvm.o
 obj-y += device.o
 
diff --git a/xen/arch/arm/domain.c b/xen/arch/arm/domain.c
index cfe0fbd..84b2f82 100644
--- a/xen/arch/arm/domain.c
+++ b/xen/arch/arm/domain.c
@@ -32,7 +32,7 @@
 
 #include <asm/gic.h>
 #include "vtimer.h"
-#include "vpl011.h"
+#include "vuart.h"
 
 DEFINE_PER_CPU(struct vcpu *, curr_vcpu);
 
@@ -518,8 +518,12 @@ int arch_domain_create(struct domain *d, unsigned int domcr_flags)
     if ( (rc = vcpu_domain_init(d)) != 0 )
         goto fail;
 
-    /* Domain 0 gets a real UART not an emulated one */
-    if ( d->domain_id && (rc = domain_uart0_init(d)) != 0 )
+    /*
+     * Virtual UART is only used by linux early printk and decompress code.
+     * Only use it for dom0 because the linux kernel may not support
+     * multi-platform.
+     */
+    if ( (d->domain_id == 0) && (rc = domain_vuart_init(d)) )
         goto fail;
 
     return 0;
@@ -535,7 +539,7 @@ void arch_domain_destroy(struct domain *d)
 {
     p2m_teardown(d);
     domain_vgic_free(d);
-    domain_uart0_free(d);
+    domain_vuart_free(d);
     free_xenheap_page(d->shared_info);
 }
 
diff --git a/xen/arch/arm/io.c b/xen/arch/arm/io.c
index ad28c26..a6db00b 100644
--- a/xen/arch/arm/io.c
+++ b/xen/arch/arm/io.c
@@ -25,7 +25,7 @@
 static const struct mmio_handler *const mmio_handlers[] =
 {
     &vgic_distr_mmio_handler,
-    &uart0_mmio_handler,
+    &vuart_mmio_handler,
 };
 #define MMIO_HANDLER_NR ARRAY_SIZE(mmio_handlers)
 
diff --git a/xen/arch/arm/io.h b/xen/arch/arm/io.h
index 661dce1..8d252c0 100644
--- a/xen/arch/arm/io.h
+++ b/xen/arch/arm/io.h
@@ -41,7 +41,7 @@ struct mmio_handler {
 };
 
 extern const struct mmio_handler vgic_distr_mmio_handler;
-extern const struct mmio_handler uart0_mmio_handler;
+extern const struct mmio_handler vuart_mmio_handler;
 
 extern int handle_mmio(mmio_info_t *info);
 
diff --git a/xen/arch/arm/vpl011.c b/xen/arch/arm/vpl011.c
deleted file mode 100644
index 13ba623..0000000
--- a/xen/arch/arm/vpl011.c
+++ /dev/null
@@ -1,152 +0,0 @@
-/*
- * xen/arch/arm/vpl011.c
- *
- * ARM PL011 UART Emulator (DEBUG)
- *
- * Ian Campbell <ian.campbell@citrix.com>
- * Copyright (c) 2012 Citrix Systems.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- */
-
-/*
- * This is not intended to be a full emulation of a PL011
- * device. Rather it is intended to provide a sufficient veneer of one
- * that early code (such as Linux's boot time decompressor) which
- * hardcodes output directly to such a device are able to make progress.
- *
- * This device is not intended to be enumerable or exposed to the OS
- * (e.g. via Device Tree).
- */
-
-#include <xen/config.h>
-#include <xen/lib.h>
-#include <xen/sched.h>
-#include <xen/errno.h>
-#include <xen/ctype.h>
-
-#include "io.h"
-
-#define UART0_START 0x1c090000
-#define UART0_END   (UART0_START+65536)
-
-#define UARTDR 0x000
-#define UARTFR 0x018
-
-int domain_uart0_init(struct domain *d)
-{
-    ASSERT( d->domain_id );
-
-    spin_lock_init(&d->arch.uart0.lock);
-    d->arch.uart0.idx = 0;
-
-    d->arch.uart0.buf = xzalloc_array(char, VPL011_BUF_SIZE);
-    if ( !d->arch.uart0.buf )
-        return -ENOMEM;
-
-    return 0;
-
-}
-
-void domain_uart0_free(struct domain *d)
-{
-    xfree(d->arch.uart0.buf);
-}
-
-static void uart0_print_char(char c)
-{
-    struct vpl011 *uart = &current->domain->arch.uart0;
-
-    /* Accept only printable characters, newline, and horizontal tab. */
-    if ( !isprint(c) && (c != '\n') && (c != '\t') )
-        return ;
-
-    spin_lock(&uart->lock);
-    uart->buf[uart->idx++] = c;
-    if ( (uart->idx == (VPL011_BUF_SIZE - 2)) || (c == '\n') )
-    {
-        if ( c != '\n' )
-            uart->buf[uart->idx++] = '\n';
-        uart->buf[uart->idx] = '\0';
-        printk(XENLOG_G_DEBUG "DOM%u: %s",
-               current->domain->domain_id, uart->buf);
-        uart->idx = 0;
-    }
-    spin_unlock(&uart->lock);
-}
-
-static int uart0_mmio_check(struct vcpu *v, paddr_t addr)
-{
-    struct domain *d = v->domain;
-
-    return d->domain_id != 0 && addr >= UART0_START && addr < UART0_END;
-}
-
-static int uart0_mmio_read(struct vcpu *v, mmio_info_t *info)
-{
-    struct hsr_dabt dabt = info->dabt;
-    struct cpu_user_regs *regs = guest_cpu_user_regs();
-    register_t *r = select_user_reg(regs, dabt.reg);
-    int offset = (int)(info->gpa - UART0_START);
-
-    switch ( offset )
-    {
-    case UARTDR:
-        *r = 0;
-        return 1;
-    case UARTFR:
-        *r = 0x87; /* All holding registers empty, ready to send etc */
-        return 1;
-    default:
-        printk("VPL011: unhandled read r%d offset %#08x\n",
-               dabt.reg, offset);
-        domain_crash_synchronous();
-    }
-}
-
-static int uart0_mmio_write(struct vcpu *v, mmio_info_t *info)
-{
-    struct hsr_dabt dabt = info->dabt;
-    struct cpu_user_regs *regs = guest_cpu_user_regs();
-    register_t *r = select_user_reg(regs, dabt.reg);
-    int offset = (int)(info->gpa - UART0_START);
-
-    switch ( offset )
-    {
-    case UARTDR:
-        /* ignore any status bits */
-        uart0_print_char((int)((*r) & 0xFF));
-        return 1;
-    case UARTFR:
-        /* Silently ignore */
-        return 1;
-    default:
-        printk("VPL011: unhandled write r%d=%"PRIregister" offset %#08x\n",
-               dabt.reg, *r, offset);
-        domain_crash_synchronous();
-    }
-}
-
-const struct mmio_handler uart0_mmio_handler = {
-    .check_handler = uart0_mmio_check,
-    .read_handler  = uart0_mmio_read,
-    .write_handler = uart0_mmio_write,
-};
-
-/*
- * Local variables:
- * mode: C
- * c-file-style: "BSD"
- * c-basic-offset: 4
- * indent-tabs-mode: nil
- * End:
- */
-
diff --git a/xen/arch/arm/vpl011.h b/xen/arch/arm/vpl011.h
deleted file mode 100644
index f0d0a82..0000000
--- a/xen/arch/arm/vpl011.h
+++ /dev/null
@@ -1,35 +0,0 @@
-/*
- * xen/arch/arm/vpl011.h
- *
- * ARM PL011 Emulation Support
- *
- * Ian Campbell <ian.campbell@citrix.com>
- * Copyright (c) 2012 Citrix Systems.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- */
-
-#ifndef __ARCH_ARM_VPL011_H__
-#define __ARCH_ARM_VPL011_H__
-
-extern int domain_uart0_init(struct domain *d);
-extern void domain_uart0_free(struct domain *d);
-
-#endif
-
-/*
- * Local variables:
- * mode: C
- * c-file-style: "BSD"
- * c-basic-offset: 4
- * indent-tabs-mode: nil
- * End:
- */
diff --git a/xen/arch/arm/vuart.c b/xen/arch/arm/vuart.c
new file mode 100644
index 0000000..5c3a84c
--- /dev/null
+++ b/xen/arch/arm/vuart.c
@@ -0,0 +1,150 @@
+/*
+ * xen/arch/arm/vuart.c
+ *
+ * Virtual UART Emulator.
+ *
+ * The emulator uses the information from dtuart. It will expose a basic
+ * UART which will allow the guest to log with an hardcode UART (early printk +
+ * decompressor).
+ *
+ * Julien Grall <julien.grall@linaro.org>
+ * Ian Campbell <ian.campbell@citrix.com>
+ * Copyright (c) 2012 Citrix Systems.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+/*
+ * This is not intended to be a full emulation of a PL011
+ * device. Rather it is intended to provide a sufficient veneer of one
+ * that early code (such as Linux's boot time decompressor) which
+ * hardcodes output directly to such a device are able to make progress.
+ *
+ * This device is not intended to be enumerable or exposed to the OS
+ * (e.g. via Device Tree).
+ */
+
+#include <xen/config.h>
+#include <xen/lib.h>
+#include <xen/sched.h>
+#include <xen/errno.h>
+#include <xen/ctype.h>
+#include <xen/serial.h>
+
+#include "vuart.h"
+#include "io.h"
+
+#define domain_has_vuart(d) ((d)->arch.vuart.info != NULL)
+
+int domain_vuart_init(struct domain *d)
+{
+    ASSERT( !d->domain_id );
+
+    d->arch.vuart.info = serial_info(SERHND_DTUART);
+    if ( !d->arch.vuart.info )
+        return 0;
+
+    spin_lock_init(&d->arch.vuart.lock);
+    d->arch.vuart.idx = 0;
+
+    d->arch.vuart.buf = xzalloc_array(char, VUART_BUF_SIZE);
+    if ( !d->arch.vuart.buf )
+        return -ENOMEM;
+
+    return 0;
+}
+
+void domain_vuart_free(struct domain *d)
+{
+    if ( !domain_has_vuart(d) )
+        return;
+
+    xfree(d->arch.vuart.buf);
+}
+
+static void vuart_print_char(char c)
+{
+    struct vuart *uart = &current->domain->arch.vuart;
+
+    /* Accept only printable characters, newline, and horizontal tab. */
+    if ( !isprint(c) && (c != '\n') && (c != '\t') )
+        return ;
+
+    spin_lock(&uart->lock);
+    uart->buf[uart->idx++] = c;
+    if ( (uart->idx == (VUART_BUF_SIZE - 2)) || (c == '\n') )
+    {
+        if ( c != '\n' )
+            uart->buf[uart->idx++] = '\n';
+        uart->buf[uart->idx] = '\0';
+        printk(XENLOG_G_DEBUG "DOM%u: %s",
+               current->domain->domain_id, uart->buf);
+        uart->idx = 0;
+    }
+    spin_unlock(&uart->lock);
+}
+
+static int vuart_mmio_check(struct vcpu *v, paddr_t addr)
+{
+    const struct serial_info *info = v->domain->arch.vuart.info;
+
+    return (domain_has_vuart(v->domain) && addr >= info->base_addr &&
+            addr <= (info->base_addr + info->size));
+}
+
+static int vuart_mmio_read(struct vcpu *v, mmio_info_t *info)
+{
+    struct domain *d = v->domain;
+    struct hsr_dabt dabt = info->dabt;
+    struct cpu_user_regs *regs = guest_cpu_user_regs();
+    register_t *r = select_user_reg(regs, dabt.reg);
+    paddr_t offset = info->gpa - d->arch.vuart.info->base_addr;
+
+    /* By default zeroed the register */
+    *r = 0;
+
+    if ( offset == d->arch.vuart.info->status_off )
+        /* All holding registers empty, ready to send etc */
+        *r = d->arch.vuart.info->status;
+
+    return 1;
+}
+
+static int vuart_mmio_write(struct vcpu *v, mmio_info_t *info)
+{
+    struct domain *d = v->domain;
+    struct hsr_dabt dabt = info->dabt;
+    struct cpu_user_regs *regs = guest_cpu_user_regs();
+    register_t *r = select_user_reg(regs, dabt.reg);
+    paddr_t offset = (int)(info->gpa - d->arch.vuart.info->base_addr);
+
+    if ( offset == d->arch.vuart.info->data_off )
+        /* ignore any status bits */
+        vuart_print_char((int)((*r) & 0xFF));
+
+    return 1;
+}
+
+const struct mmio_handler vuart_mmio_handler = {
+    .check_handler = vuart_mmio_check,
+    .read_handler  = vuart_mmio_read,
+    .write_handler = vuart_mmio_write,
+};
+
+/*
+ * Local variables:
+ * mode: C
+ * c-file-style: "BSD"
+ * c-basic-offset: 4
+ * indent-tabs-mode: nil
+ * End:
+ */
+
diff --git a/xen/arch/arm/vuart.h b/xen/arch/arm/vuart.h
new file mode 100644
index 0000000..9445e50
--- /dev/null
+++ b/xen/arch/arm/vuart.h
@@ -0,0 +1,35 @@
+/* 
+ * xen/arch/arm/vuart.h
+ *
+ * Virtual UART Emulation Support
+ *
+ * Ian Campbell <ian.campbell@citrix.com>
+ * Copyright (c) 2012 Citrix Systems.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef __ARCH_ARM_VUART_H__
+#define __ARCH_ARM_VUART_H__
+
+int domain_vuart_init(struct domain *d);
+void domain_vuart_free(struct domain *d);
+
+#endif /* __ARCH_ARM_VUART_H__ */
+
+/*
+ * Local variables:
+ * mode: C
+ * c-file-style: "BSD"
+ * c-basic-offset: 4
+ * indent-tabs-mode: nil
+ * End:
+ */
diff --git a/xen/include/asm-arm/domain.h b/xen/include/asm-arm/domain.h
index 19bbe8a..216ce0b 100644
--- a/xen/include/asm-arm/domain.h
+++ b/xen/include/asm-arm/domain.h
@@ -9,6 +9,7 @@
 #include <asm/vfp.h>
 #include <public/hvm/params.h>
 #include <asm/atomic.h>
+#include <xen/serial.h>
 
 /* Represents state corresponding to a block of 32 interrupts */
 struct vgic_irq_rank {
@@ -104,12 +105,13 @@ struct arch_domain
         paddr_t cbase; /* CPU base address */
     } vgic;
 
-    struct vpl011 {
-#define VPL011_BUF_SIZE 128
-        char                  *buf;
-        int                    idx;
-        spinlock_t             lock;
-    } uart0;
+    struct vuart {
+#define VUART_BUF_SIZE 128
+        char                        *buf;
+        int                         idx;
+        const struct serial_info    *info;
+        spinlock_t                  lock;
+    } vuart;
 
 }  __cacheline_aligned;
 